/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.veranstaltung;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.veranstaltung.boundary.AbstractTeilnahmeSearchParameters;
import de.ivu.elect.business.veranstaltung.boundary.TeilnahmeChangeEvent;
import de.ivu.elect.business.veranstaltung.boundary.TeilnahmeConversationStore;
import de.ivu.elect.business.veranstaltung.boundary.TeilnahmeExtendedDAO;
import de.ivu.elect.business.veranstaltung.boundary.TeilnahmeSearch;
import de.ivu.elect.business.veranstaltung.boundary.TeilnahmeSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.veranstaltung.entity.Teilnahme;
import de.ivu.elect.business.veranstaltung.entity.TeilnahmeMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractTeilnahmeSearchView.COMPONENT_NAME)
@View(viewId = AbstractTeilnahmeSearchView.VIEW_ID, useCase = UseCasePermission.TEILNAHME_SEARCH)
public abstract class AbstractTeilnahmeSearchView extends AbstractElectSearchView<Teilnahme> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "teilnahmeSearchView";
  
  public static final String VIEW_ID = "/veranstaltung/teilnahme-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractTeilnahmeSearchView requestHandler;

  @Inject
  private transient TeilnahmeExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(TeilnahmeConversationStore.class)
  protected transient TeilnahmeConversationStore conversationStore;

  @Inject
  protected transient TeilnahmeSearch search;

  @Inject
  @ConversationGroup(AbstractTeilnahmeSearchParameters.class)
  protected transient TeilnahmeSearchParameters searchParameters;

  @Inject
  protected transient TeilnahmeMeta entityMeta;

  public AbstractTeilnahmeSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public Teilnahme getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(Teilnahme entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public TeilnahmeSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<Teilnahme> getEagerLoadingCollector() {
    return EagerLoadingCollector.<Teilnahme> create();
  }

  @Override
  public List<Teilnahme> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<Teilnahme> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onTeilnahmeChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) TeilnahmeChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  //   Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractTeilnahmeSearchView {

    @View
    @Inject
    private transient Instance<AbstractTeilnahmeSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractTeilnahmeSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
